/*
Copyright (c) 2014-2016 Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
typedef struct cfg_page_prop {
  int window_border; char G_window_border;
  int window; char G_window;
  int root; char G_root;
} cfg_page_prop_t;
typedef struct cfg_pager_style {
  int border; char G_border;
  cfg_page_prop_t inactive;
  cfg_page_prop_t active;
} cfg_pager_style_t;
typedef struct cfg_clock {
  int font_size; char G_font_size;
  char* font_name; char G_font_name;
  int pad; char G_pad;
  int bg; char G_bg;
  int fg; char G_fg;
} cfg_clock_t;
typedef struct cfg_taskbar {
  int mid; char G_mid;
  int right; char G_right;
  int left; char G_left;
  int active; char G_active;
  int max_size; char G_max_size;
  int border; char G_border;
  int icon_size; char G_icon_size;
  int font_size; char G_font_size;
  char* font_name; char G_font_name;
  int bg; char G_bg;
  int fg; char G_fg;
} cfg_taskbar_t;
typedef struct cfg_menu_style {
  int hilight; char G_hilight;
  int sepcolor; char G_sepcolor;
  int sepv; char G_sepv;
  int seph; char G_seph;
  int fg; char G_fg;
  int bg; char G_bg;
  char* font_name; char G_font_name;
  int font_size; char G_font_size;
  int icon_h; char G_icon_h;
  int icon_w; char G_icon_w;
  int vspc; char G_vspc;
  int mid2; char G_mid2;
  int mid; char G_mid;
  int right; char G_right;
  int left; char G_left;
} cfg_menu_style_t;
typedef struct cfg_switcher {
  int enabled; char G_enabled;
  char* font_name; char G_font_name;
  int font_size; char G_font_size;
  int width; char G_width;
  int pad_icon; char G_pad_icon;
  int pad_horz; char G_pad_horz;
  int pad_bot; char G_pad_bot;
  int pad_mid; char G_pad_mid;
  int pad_top; char G_pad_top;
  int hilight; char G_hilight;
  int bg; char G_bg;
  int fg; char G_fg;
} cfg_switcher_t;
typedef struct cfg_top {
  int window_close_shortcut; char G_window_close_shortcut;
  int retain_desktop_number; char G_retain_desktop_number;
  int override_redirect; char G_override_redirect;
  char* right_box_file; char G_right_box_file;
  char* left_box_file; char G_left_box_file;
  int button_size; char G_button_size;
  int spacing; char G_spacing;
  int left; char G_left;
  int right; char G_right;
  int fg; char G_fg;
  int bg; char G_bg;
  int height; char G_height;
  char* *menu_shortcut_path; int N_menu_shortcut_path; int S_menu_shortcut_path;
  char* *menu_icon_path; int N_menu_icon_path; int S_menu_icon_path;
  cfg_switcher_t switcher;
  cfg_menu_style_t menu_style;
  int clock_on; char G_clock_on;
  cfg_clock_t clock;
  cfg_taskbar_t taskbar;
  cfg_pager_style_t pager_style;
} cfg_top_t;
char *cfg_parse_top(char *fn, cfg_top_t *obj);
char *cfg_write_top(char *fn, cfg_top_t *obj);
