/*
Copyright (c) 2014-2016 Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
#line 362 "/home/dodo/tmp/mupanel-orig-1.5/src/x-props.u"
#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include "x-basics.h"
#include "x-props.h"

#line 13 "/home/dodo/tmp/mupanel-orig-1.5/src/x-props.u"

#line 14 "x-props.c"
Atom a_utf8_string,
  a_net_current_desktop,
  a_net_number_of_desktops,
  a_net_supported,
  a_net_client_list,
  a_net_client_list_stacking,
  a_net_wm_desktop,
  a_net_active_window,
  a_net_desktop_geometry,
  a_net_supporting_wm_check,
  a_net_wm_icon,
  a_net_wm_name,
  a_net_wm_visible_name,
  a_net_wm_icon_name,
  a_net_wm_visible_icon_name,
  a_net_wm_strut,
  a_net_wm_strut_partial,
  a_wm_name,
  a_wm_icon_name,
  a_wm_protocols,
  a_wm_delete_window,
  a_wm_window_role,
  a_wm_state,
  a_net_wm_window_type,
  a_net_wm_window_type_dock,
  a_net_wm_window_type_normal,
  a_net_wm_window_type_popup_menu,
  a_net_wm_state,
  a_net_wm_state_sticky,
  a_net_wm_state_skip_taskbar,
  a_net_wm_state_skip_pager,
  a_net_wm_state_hidden,
  a_net_wm_state_above,
  a_net_frame_extents,
  a_string;
#line 34 "/home/dodo/tmp/mupanel-orig-1.5/src/x-props.u"

void x_atoms_init()
{
   typedef struct { char* name; Atom *atom; } atomdesc_t;
   static atomdesc_t atoms[]=
   {
#line 56 "x-props.c"
  { "UTF8_STRING", &a_utf8_string },
  { "_NET_CURRENT_DESKTOP", &a_net_current_desktop },
  { "_NET_NUMBER_OF_DESKTOPS", &a_net_number_of_desktops },
  { "_NET_SUPPORTED", &a_net_supported },
  { "_NET_CLIENT_LIST", &a_net_client_list },
  { "_NET_CLIENT_LIST_STACKING", &a_net_client_list_stacking },
  { "_NET_WM_DESKTOP", &a_net_wm_desktop },
  { "_NET_ACTIVE_WINDOW", &a_net_active_window },
  { "_NET_DESKTOP_GEOMETRY", &a_net_desktop_geometry },
  { "_NET_SUPPORTING_WM_CHECK", &a_net_supporting_wm_check },
  { "_NET_WM_ICON", &a_net_wm_icon },
  { "_NET_WM_NAME", &a_net_wm_name },
  { "_NET_WM_VISIBLE_NAME", &a_net_wm_visible_name },
  { "_NET_WM_ICON_NAME", &a_net_wm_icon_name },
  { "_NET_WM_VISIBLE_ICON_NAME", &a_net_wm_visible_icon_name },
  { "_NET_WM_STRUT", &a_net_wm_strut },
  { "_NET_WM_STRUT_PARTIAL", &a_net_wm_strut_partial },
  { "WM_NAME", &a_wm_name },
  { "WM_ICON_NAME", &a_wm_icon_name },
  { "WM_PROTOCOLS", &a_wm_protocols },
  { "WM_DELETE_WINDOW", &a_wm_delete_window },
  { "WM_WINDOW_ROLE", &a_wm_window_role },
  { "WM_STATE", &a_wm_state },
  { "_NET_WM_WINDOW_TYPE", &a_net_wm_window_type },
  { "_NET_WM_WINDOW_TYPE_DOCK", &a_net_wm_window_type_dock },
  { "_NET_WM_WINDOW_TYPE_NORMAL", &a_net_wm_window_type_normal },
  { "_NET_WM_WINDOW_TYPE_POPUP_MENU", &a_net_wm_window_type_popup_menu },
  { "_NET_WM_STATE", &a_net_wm_state },
  { "_NET_WM_STATE_STICKY", &a_net_wm_state_sticky },
  { "_NET_WM_STATE_SKIP_TASKBAR", &a_net_wm_state_skip_taskbar },
  { "_NET_WM_STATE_SKIP_PAGER", &a_net_wm_state_skip_pager },
  { "_NET_WM_STATE_HIDDEN", &a_net_wm_state_hidden },
  { "_NET_WM_STATE_ABOVE", &a_net_wm_state_above },
  { "_NET_FRAME_EXTENTS", &a_net_frame_extents },
  { "STRING", &a_string },
#line 58 "/home/dodo/tmp/mupanel-orig-1.5/src/x-props.u"
      { NULL, NULL }
   };
   int i;
   for(i=0;atoms[i].name;i++)
     if ((atoms[i].atom[0]= XInternAtom(x_display, atoms[i].name, False))
            ==None)
     {
           // FIXME: proper logging
       fprintf(stderr,"Can't intern atom %s\n", atoms[i].name);
     }
}

#line 118 "/home/dodo/tmp/mupanel-orig-1.5/src/x-props.u"

int get_window_property
    (Window window, Atom property, Atom type,
     Atom *Rtype,int *Rformat,  int *Rsize, void **Rdata,
     unsigned long max_size)
{
  unsigned long bytes_remaining;
  unsigned long r_nitems;

  *Rdata= NULL;
  if (x_display==NULL || property==None) goto fail_bad_usage; 
  if (window==None) window= x_root_window;

   if (!max_size) max_size= -1L; else max_size/= 4;
   if (XGetWindowProperty(x_display, window, property, 
                 0, // offset
                 max_size, // length in 32-bit items.. stuuupid.
                False, // delete
                type, 
             Rtype, Rformat, &r_nitems, 
             &bytes_remaining, // this one is in BYTES.
             (unsigned char**) Rdata)!=Success) return 1;

  if (*Rformat==32) *Rformat= sizeof(unsigned long)*8;
  *Rsize= r_nitems * Rformat[0]/8;
  
  return 0;

fail_bad_usage:
  fprintf(stderr,"bad usage in get_window_property\n");
  return 1;
}

#line 156 "/home/dodo/tmp/mupanel-orig-1.5/src/x-props.u"

int get_window_property_cardinals
    (Window window, Atom property, size_t *Rn, unsigned long **R, int maxn)
{
  int format; Atom type;
  int size; 

  *R= NULL;
  if (get_window_property(window, property, XA_CARDINAL,
                          &type, &format, &size, (void**) R,
                          maxn*sizeof(unsigned long)))
     return 1;
  if (type!=XA_CARDINAL)
  {
    if (*R) free(*R);
    // FIXME: get the name of the atom to print this better.
    // FIXME log this.
    //fprintf(stderr,"type mismatch in get_window_property \n"
                   //"expected a 32-bit uint32_t, but got a %-bit %d\n",
                              //format, type);
    return 1;
  }
  *Rn= size / sizeof(unsigned long);
  return 0;
}


int get_window_property_cardinal
    (Window window, Atom property, unsigned long *R)
{
  unsigned long *data;
  size_t n;
  if (get_window_property_cardinals(window,property, &n, &data, 1))
     return 1;
  if (n==0) { if (data) free(data); return 1; }
  *R= data[0];
  free(data);
  return 0;
}

#line 200 "/home/dodo/tmp/mupanel-orig-1.5/src/x-props.u"

int get_window_property_windows
    (Window window, Atom property, size_t *Rn, Window **R, int maxn)
{
  int format; Atom type;
  int size; 

  *R= NULL;
  if (get_window_property(window, property, XA_WINDOW,
                          &type, &format, &size, (void**) R,
                          maxn*sizeof(Window)))
     return 1;
  if (type!=XA_WINDOW)
  {
    if (*R) free(*R);
    // FIXME: get the name of the atom to print this better.
    // FIXME log this.
    //fprintf(stderr,"type mismatch in get_window_property \n"
                   //"expected a window, but got a %d-bit %d\n",
                              //format, type);
    return 1;
  }

  *Rn= size/sizeof(Window); 
  return 0;
}

int get_window_property_atoms
    (Window window, Atom property, size_t *Rn, Atom **R, int maxn)
{
  int format; Atom type;
  int size; 

  *R= NULL;
  if (get_window_property(window, property, XA_ATOM,
                          &type, &format, &size, (void**) R,
                          maxn*sizeof(Atom)))
     return 1;
  if (type!=XA_ATOM)
  {
    if (*R) free(*R);
    // FIXME: get the name of the atom to print this better.
    // FIXME log this.
    //fprintf(stderr,"type mismatch in get_window_property \n"
                   //"expected an Atom , but got a %d-bit %d\n",
                              //format, type);
    return 1;
  }

  *Rn= size/sizeof(Atom); 
  return 0;
}


int get_window_property_window
    (Window window, Atom property, Window *R)
{
  Window *data;
  size_t n;
  if (get_window_property_windows(window,property, &n, &data, 1))
     return 1;
  if (n==0) { if (data) free(data); return 1; }
  *R= data[0];
  free(data);
  return 0;
}


int get_window_property_utf8_string
    (Window window, Atom property, size_t *Rn, char **R)
{
  int format; Atom type;
  int size; void *data;
  if (get_window_property(window, property, a_utf8_string,
                          &type, &format, &size, &data, 0))
     return 1;
  if (format!=8 || type!=a_utf8_string)
  {
    if (data) free(data);
    // FIXME: get the name of the atom to print this better.
    // FIXME log this.
    //fprintf(stderr,"type mismatch in get_window_property \n"
                   //"expected a utf8-string, but got a %-bit %d\n",
                              //format, type);
    return 1;
  }
  *Rn= size;
  *R= (char*) data;
  return 0;
}

int get_window_property_string
    (Window window, Atom property, size_t *Rn, char **R)
{
  int format; Atom type;
  int size; void *data;
  if (get_window_property(window, property, a_string,
                          &type, &format, &size, &data, 0))
     return 1;
  if (format!=8 || type!=a_string)
  {
    if (data) free(data);
    // FIXME: get the name of the atom to print this better.
    // FIXME log this.
    //fprintf(stderr,"type mismatch in get_window_property \n"
                   //"expected a utf8-string, but got a %-bit %d\n",
                              //format, type);
    return 1;
  }
  *Rn= size;
  *R= (char*) data;
  return 0;
}
#line 319 "/home/dodo/tmp/mupanel-orig-1.5/src/x-props.u"

int set_window_property_atoms
        (Window window, Atom property, int n_values, Atom *values)
{
  XChangeProperty(x_display, window, property, XA_ATOM, 32, 
                  PropModeReplace, (unsigned char*) values, n_values);
  return 0;
}

int set_window_property_cardinals
        (Window window, Atom property, int n_values, unsigned long *values)
{
  XChangeProperty(x_display, window, property, XA_CARDINAL, 32, 
                  PropModeReplace, (unsigned char*) values, n_values);
  return 0;
}

int set_window_property_cardinal
        (Window window, Atom property, unsigned long value)
{
  XChangeProperty(x_display, window, property, XA_CARDINAL, 32, 
                  PropModeReplace, (unsigned char*) &value, 1);
  return 0;
}

int set_window_property_string
        (Window window, Atom property, char *str)
{
  XChangeProperty(x_display, window, property, a_string, 8, 
                  PropModeReplace, (unsigned char*) str, strlen(str)+1);
  return 0;
}

#line 374 "/home/dodo/tmp/mupanel-orig-1.5/src/x-props.u"

